luogu4336(矩阵树定理+容斥)

题目链接

https://www.luogu.org/problem/P4336

题解

虽然生成树计数确实会想到矩阵树定理,不过因为感觉用不上去于是走在了状压的不归路上QAQ

如果硬套矩阵树定理会发现可能会出现一个人占据多条边的情况,其实这意味着有些人没有支配着边,所以只需要排除掉非全集的情况就可以了,容斥也就显而易见。。

还是太菜了。。




代码

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
/**
*         ┏┓    ┏┓
*         ┏┛┗━━━━━━━┛┗━━━┓
*         ┃       ┃  
*         ┃   ━    ┃
*         ┃ >   < ┃
*         ┃       ┃
*         ┃... ⌒ ...  ┃
*         ┃ ┃
*         ┗━┓ ┏━┛
*          ┃ ┃ Code is far away from bug with the animal protecting          
*          ┃ ┃ 神兽保佑,代码无bug
*          ┃ ┃           
*          ┃ ┃       
*          ┃ ┃
*          ┃ ┃           
*          ┃ ┗━━━┓
*          ┃ ┣┓
*          ┃ ┏┛
*          ┗┓┓┏━━━━━━━━┳┓┏┛
*           ┃┫┫ ┃┫┫
*           ┗┻┛ ┗┻┛
*/

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<queue>
#include<map>
#include<stack>
#include<cmath>
#include<set>
#include<bitset>
#include<complex>
#include<cstdlib>
#include<assert.h>
#define inc(i,l,r) for(int i=l;i<=r;i++)
#define dec(i,l,r) for(int i=l;i>=r;i--)
#define link(x) for(edge *j=h[x];j;j=j->next)
#define mem(a) memset(a,0,sizeof(a))
#define ll long long
#define mid (x+y>>1)
#define eps 1e-8
#define succ(x) (1<<(x))
#define lowbit(x) (x&(-x))
#define sqr(x) ((x)*(x))
#define NM 18
#define nm 20000005
using namespace std;
const double pi=acos(-1);
const ll inf=1e9+7;
ll read(){
ll x=0,f=1;char ch=getchar();
while(!isdigit(ch)){if(ch=='-')f=-1;ch=getchar();}
while(isdigit(ch))x=x*10+ch-'0',ch=getchar();
return f*x;
}


inline void reduce(ll&x){x+=x>>63&inf;}
inline ll qpow(ll x,ll t){
ll s=1;
for(;t;t>>=1,x=x*x%inf)if(t&1)s=s*x%inf;
return s;
}
int n,tot,_x,_y;
ll a[NM][NM];
struct P{int x,y;};
vector<P>vec[NM];
ll ans;


ll cal(){
ll s=1;
int cnt=0;
inc(i,1,n)inc(j,1,n)reduce(a[i][j]);
inc(i,1,n)inc(j,i+1,n){
for(int x=i,y=j;a[y][i];swap(x,y)){
ll t=a[x][i]*qpow(a[y][i],inf-2)%inf;
inc(k,i,n)reduce(a[x][k]-=t*a[y][k]%inf);
}
if(!a[i][i])swap(a[i],a[j]),cnt^=1;
}
inc(i,1,n)s=s*a[i][i]%inf;
if(cnt)reduce(s=-s);
return s;
}

int main(){
n=read()-1;tot=succ(n)-1;
inc(i,1,n){
int m=read();
while(m--){
_x=read();_y=read();
vec[i].push_back({_x,_y});
}
}
inc(i,0,tot){
mem(a);
inc(j,1,n)if(i>>(j-1)&1)for(auto&k:vec[j]){
a[k.x][k.y]--;a[k.y][k.x]--;
a[k.x][k.x]++;a[k.y][k.y]++;
}
if(__builtin_popcount(i^tot)&1)reduce(ans-=cal());
else reduce(ans+=cal()-inf);
}
printf("%lld\n",ans);
return 0;
}